//
//  CIFaceDetectorHandler.m
//  FaceDetection
//
//  Created by Michael Conrads on 23.09.13.
//  Copyright (c) 2013 Michael Conrads. All rights reserved.
//

#import "CIFaceDetectorHandler.h"

@interface CIFaceDetectorHandler()
@property (nonatomic, assign) CGAffineTransform transformToUIKit;
@end

@implementation CIFaceDetectorHandler

- (void) addFaceFeaturesOfImage:(UIImage *) image toView:(UIView *) view
{
	//this is the translation from the CIImage coordinates to the UIKit coordinates
	CGAffineTransform transform = CGAffineTransformMakeScale(1, -1);
	self.transformToUIKit = CGAffineTransformTranslate(transform, 0, -image.size.height);
	
	
	//a context and our image to get started!
	CIContext *context = [CIContext contextWithOptions:nil];
	CIImage * coreImage = 	[[CIImage alloc] initWithImage:image];

	
	//TODO: 14 create a NSDictionary with the key CIDetectorAccuracy set to CIDetectorAccuracyHigh
	
	
	
	//TODO: 15 create a CIDetector of type CIDetectorTypeFace
	//HINT: use the context from the top and the detectorOptions you just created

	
	
	//TODO: 16 get all CIFaceFeatures the detector can find in the coreImage
	//HINT: use -featuresInImage:

	
	
	//TODO: 17 loop over the CIFaceFeatures and mark each face you found with the -addRectangleFromCGRect:toView:withColor: method
	//HINT: the position of the face can be found in the bounds-property

	
	//TODO: 18 Now mark the left and right eye as well as the mouth. (also in the loop)
	//HINT: use leftEyePosition, rightEyePosition, mouthPosition as well as -addCircleAroundPoint:toView:withColor:andWidth:
	
}



/**
 *  Adds a rectangle-view to the passed view
 *
 *  @param rect  the dimensions and position of the new rectangle
 *  @param view  the parent-view
 *  @param color the color of the rectangle (will have an alpha-value of 0.3)
 */
- (void) addRectangleFromCGRect:(CGRect)rect toView:(UIView *) view withColor:(UIColor *) color
{
	CGRect translatedRect = CGRectApplyAffineTransform(rect, self.transformToUIKit);
	
	UIView * newView = [[UIView alloc] initWithFrame:translatedRect];
	newView.layer.cornerRadius = 10;
	newView.alpha = 0.3;
	newView.backgroundColor = color;
	[view addSubview:newView];
}


/**
 *  adds a circle-view to the passed view
 *
 *  @param point the center of the circle
 *  @param view  the parent-view
 *  @param color the color of the circle (will have an alpha-value of 0.3)
 *  @param width the diameter of the circle
 */
- (void) addCircleAroundPoint:(CGPoint) point toView:(UIView *) view withColor:(UIColor *) color andWidth:(NSInteger) width
{
	CGPoint translatedPoint = CGPointApplyAffineTransform(point, self.transformToUIKit);
	CGRect circleRect = CGRectMake(translatedPoint.x-width/2, translatedPoint.y-width/2, width, width);

	UIView * circleView = [[UIView alloc] initWithFrame:circleRect];
	circleView.layer.cornerRadius = width/2;
	circleView.alpha = 0.7;
	circleView.backgroundColor = color;
	[view addSubview:circleView];
}

@end
